<ng-container *ngIf="vm$ | async as vm">
  <div [ngClass]="[jds.tableResponsive]">
    <table
      [ngClass]="['table-e-walidata-assign', jds.table, jds.mb(0)]"
      role="table"
      aria-label="List E-Walidata Assign"
      aria-describedby="Table List E-Walidata Assign"
    >
      <thead
        [ngClass]="[
          jds.bg(jdsBiColor.gray['100']),
          jds.text(jdsBiColor.gray['700'])
        ]"
      >
        <tr>
          <th [style.width.%]="3"></th>
          <th
            [style.width.%]="15"
            [colorScheme]="'gray'"
            [isSortable]="true"
            [currentSort]="{
              sort: checkSort(id, vm.filterSortIndicator),
              direction: checkDirection(id, vm.filterDirectionIndicator)
            }"
            (filterSort)="
              onSort(
                id,
                $event,
                checkDirection(id, vm.filterDirectionIndicator)
              )
            "
            jdsBiTableHead
            scope="col"
            column="kode_indikator"
          >
            Kode DSSD
          </th>
          <th
            *ngIf="satudataUser.role_name === 'walidata'"
            [style.width.%]="15"
            [colorScheme]="'gray'"
            [isSortable]="true"
            [isFilterable]="true"
            [currentSort]="{
              sort: checkSort(id, vm.filterSortIndicator),
              direction: checkDirection(id, vm.filterDirectionIndicator)
            }"
            (filterSort)="
              onSort(
                id,
                $event,
                checkDirection(id, vm.filterDirectionIndicator)
              )
            "
            jdsBiTableHead
            scope="col"
            column="status_available"
          >
            <span>Status</span>
            <div
              [style.cursor]="'pointer'"
              filter
              role="button"
            >
              <jds-bi-hosted-dropdown
                [(open)]="isOpenStatusAvailable"
                [jdsBiDropdownLimitWidth]="'custom'"
                [jdsBiDropdownMinWidth]="240"
                [content]="dropdownStatusAvailable"
              >
                <i
                  class="tblhd-icon"
                  [ngClass]="['active']"
                ></i>
              </jds-bi-hosted-dropdown>
            </div>
          </th>
          <th [style.width.%]="satudataUser.role_name === 'walidata' ? 45 : 60">
            Uraian
          </th>
          <th [style.width.%]="10">Satuan</th>
          <th
            [style.width.%]="15"
            [colorScheme]="'gray'"
            [isSortable]="true"
            [isFilterable]="satudataUser.role_name === 'walidata'"
            [currentSort]="{
              sort: checkSort(id, vm.filterSortIndicator),
              direction: checkDirection(id, vm.filterDirectionIndicator)
            }"
            (filterSort)="
              onSort(
                id,
                $event,
                checkDirection(id, vm.filterDirectionIndicator)
              )
            "
            jdsBiTableHead
            scope="col"
            column="status_assignment"
          >
            <span>Tindak Lanjut</span>
            <div
              [style.cursor]="'pointer'"
              filter
              role="button"
            >
              <jds-bi-hosted-dropdown
                [(open)]="isOpenStatusAssignment"
                [jdsBiDropdownLimitWidth]="'custom'"
                [jdsBiDropdownMinWidth]="240"
                [jdsBiDropdownAlign]="'right'"
                [content]="dropdownStatusAssignment"
              >
                <i
                  class="tblhd-icon"
                  [ngClass]="['active']"
                ></i>
              </jds-bi-hosted-dropdown>
            </div>
          </th>
        </tr>
      </thead>
      <tbody>
        <ng-container *ngIf="vm.listEWalidataAssignIndicator as lists">
          <ng-container *ngIf="lists[id] as list">
            <ng-container *ngIf="list.status === 'loading'">
              <ng-container *ngTemplateOutlet="loading" />
            </ng-container>

            <ng-container *ngIf="list.status === 'success'">
              <ng-container *ngIf="list.data; else empty">
                <ng-container *ngIf="list.data.list.length > 0">
                  <tr
                    *ngFor="let row of list.data.list; let i = index"
                    [ngClass]="row.checked ? jds.bg('#F4F8FB') : ''"
                  >
                    <td [style.width.%]="3">
                      <div [ngClass]="[jds.formCheck]">
                        <input
                          id="checkbox-business-field-indicator-{{ i }}"
                          [(ngModel)]="row.checked"
                          [ngClass]="['checkbox-indicator', jds.formCheckInput]"
                          [disabled]="
                            checkCheckboxDisable(
                              row.status_available,
                              row.status_assignment
                            )
                          "
                          (change)="
                            onSelected(
                              {
                                businessFieldId: id,
                                businessFieldName: name,
                                indicatorId: row.kode_indikator,
                                indicatorName: row.nama_indikator,
                                indicatorStatus: row.status_assignment,
                                assignmentId: row.id_assignment,
                                assignmentOrganization: row.kode_skpd
                              },
                              $event.target.checked
                            )
                          "
                          type="checkbox"
                        />
                      </div>
                    </td>
                    <td
                      [style.width.%]="15"
                      [ngClass]="[
                        row.status_available === 'Tidak Aktif'
                          ? jds.text(jdsBiColor.gray['500'])
                          : ''
                      ]"
                    >
                      {{ row.kode_indikator }}
                    </td>
                    <td
                      *ngIf="satudataUser.role_name === 'walidata'"
                      [style.width.%]="15"
                    >
                      <ng-container
                        [ngTemplateOutlet]="badgeStatusAvailable"
                        [ngTemplateOutletContext]="{
                          status: row.status_available
                        }"
                      />
                    </td>
                    <td
                      [style.width.%]="
                        satudataUser.role_name === 'walidata' ? 45 : 60
                      "
                      [ngClass]="[
                        row.status_available === 'Tidak Aktif'
                          ? jds.text(jdsBiColor.gray['500'])
                          : ''
                      ]"
                    >
                      {{ row.nama_indikator }}
                    </td>
                    <td
                      [style.width.%]="10"
                      [ngClass]="[
                        row.status_available === 'Tidak Aktif'
                          ? jds.text(jdsBiColor.gray['500'])
                          : ''
                      ]"
                    >
                      {{ row.satuan }}
                    </td>
                    <td
                      [style.width.%]="15"
                      [ngClass]="[jds.textAlign('right')]"
                    >
                      <ng-container *ngIf="row.status_assignment !== null">
                        <ng-container
                          *ngIf="getHistory(row.history) as history"
                        >
                          <ng-container
                            [ngTemplateOutlet]="badgeStatusAssignment"
                            [ngTemplateOutletContext]="{
                              status: row.status_assignment,
                              tooltip: row.status_assignment !== null,
                              tooltipStatus: history.status_assignment,
                              tooltipName: history.name,
                              tooltipOrganization: history.nama_skpd,
                              tooltipNote: history.note,
                              tooltipDate: history.date
                            }"
                          />
                        </ng-container>
                      </ng-container>
                    </td>
                  </tr>
                </ng-container>

                <ng-container *ngIf="list.data.list.length === 0">
                  <ng-container *ngTemplateOutlet="empty" />
                </ng-container>
              </ng-container>
            </ng-container>
          </ng-container>
        </ng-container>
      </tbody>
    </table>
  </div>
</ng-container>

<ng-template #dropdownStatusAvailable>
  <div [ngClass]="[jds.px(16), jds.pt(12), jds.pb(8)]">
    <ul
      [ngClass]="[jds.ps(0), jds.mb(0)]"
      [style.listStyle]="'none'"
      [style.height]="'auto'"
    >
      <li
        *ngFor="let item of statusAvailable"
        [ngClass]="[jds.mb(5), jds.pe(15)]"
      >
        <div [ngClass]="[jds.formCheck]">
          <input
            id="checkbox-status-available-{{ item.id }}"
            [(ngModel)]="item.checked"
            [ngClass]="[jds.formCheckInput]"
            (change)="
              onFilterStatusAvailable(id, item.name, $event.target.checked)
            "
            type="checkbox"
          />
          <label
            [ngClass]="[jds.formCheckLabel]"
            for="checkbox-status-available-{{ item.id }}"
          >
            <ng-container
              [ngTemplateOutlet]="badgeStatusAvailable"
              [ngTemplateOutletContext]="{
                status: item.name
              }"
            />
          </label>
        </div>
      </li>
    </ul>
  </div>
</ng-template>

<ng-template
  #badgeStatusAvailable
  let-status="status"
>
  <span
    [ngClass]="[
      jds.alignItems('center'),
      status === 'Tidak Aktif' ? jds.borderColor(jdsBiColor.gray['500']) : '',
      status === 'Tidak Aktif' ? jds.text(jdsBiColor.gray['500']) : ''
    ]"
    [colorScheme]="getStatusAvailable(status)"
    [variant]="'outline'"
    [isRounded]="true"
    jdsBiBadge
  >
    <div [ngClass]="[jds.me(8)]">
      <ng-container *ngTemplateOutlet="iconCircle" />
    </div>
    <span>{{ status }}</span>
  </span>
</ng-template>

<ng-template #iconCircle>
  <svg
    width="7"
    height="7"
    viewBox="0 0 7 7"
    fill="currentColor"
    xmlns="http://www.w3.org/2000/svg"
  >
    <circle
      id="Ellipse 22"
      cx="3.5"
      cy="3.5"
      r="3.5"
    />
  </svg>
</ng-template>

<ng-template #dropdownStatusAssignment>
  <div [ngClass]="[jds.px(16), jds.pt(12), jds.pb(8)]">
    <ul
      [ngClass]="[jds.ps(0), jds.mb(0)]"
      [style.listStyle]="'none'"
      [style.height]="'auto'"
    >
      <li
        *ngFor="let item of statusAssignment"
        [ngClass]="[jds.mb(5), jds.pe(15)]"
      >
        <div [ngClass]="[jds.formCheck]">
          <input
            id="checkbox-status-assignment-{{ item.id }}"
            [(ngModel)]="item.checked"
            [ngClass]="[jds.formCheckInput]"
            (change)="
              onFilterStatusAssignment(id, item.name, $event.target.checked)
            "
            type="checkbox"
          />
          <label
            [ngClass]="[jds.formCheckLabel]"
            for="checkbox-status-assignment-{{ item.id }}"
          >
            <ng-container
              [ngTemplateOutlet]="badgeStatusAssignment"
              [ngTemplateOutletContext]="{
                status: item.name,
                tooltip: false
              }"
            />
          </label>
        </div>
      </li>
    </ul>
  </div>
</ng-template>

<ng-template
  #badgeStatusAssignment
  let-status="status"
  let-tooltip="tooltip"
  let-tooltipStatus="tooltipStatus"
  let-tooltipName="tooltipName"
  let-tooltipOrganization="tooltipOrganization"
  let-tooltipNote="tooltipNote"
  let-tooltipDate="tooltipDate"
>
  <span
    [ngClass]="[jds.alignItems('center')]"
    [colorScheme]="getStatusAssignment(status)"
    [variant]="'subtle'"
    [popperApplyClass]="'tooltip-e-walidata-assign'"
    [popperDisabled]="!tooltip"
    [popperPlacement]="'left'"
    [popperTrigger]="'hover'"
    [popper]="
      getNote({
        status: tooltipStatus,
        name: tooltipName,
        organization: tooltipOrganization,
        note: tooltipNote,
        date: tooltipDate
      })
    "
    jdsBiBadge
  >
    {{ status }}
  </span>
</ng-template>

<ng-template #empty>
  <tr>
    <td
      [style.width.%]="100"
      [attr.colspan]="6"
      [ngClass]="[jds.textAlign('center')]"
    >
      Tidak ada Data.
    </td>
  </tr>
</ng-template>

<ng-template #loading>
  <tr *ngFor="let i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]">
    <td
      *ngFor="let j of [0, 15, 15, 45, 10, 15]"
      [style.width.%]="j"
    >
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: '80%',
            'border-radius': '0',
            height: '22px',
            'margin-bottom': '0px'
          }"
        />
      </div>
    </td>
  </tr>
</ng-template>
